<?php
$timeout = 180;
$apiKey = "QuasarLabsAndGuruSolutions";

$input = file_get_contents('php://input');
$body = json_decode($input, true);
$data = $body["data"];
$decoded_data = (base64_decode($data));
$mData = json_decode($decoded_data, true);

$salt = $mData["salt"];
$endpoint = $mData["endpoint"];
$deviceId = $mData["deviceId"];
$hash = $mData["hash"];
$timestamp = $mData["timestamp"];
$uid = $mData["uid"];
$req = $mData["input"];

$currentTime = time();
$formattedTs = $timestamp / 1000;

$diff = $currentTime - $formattedTs;

// if ($diff > $timeout) {
//     require "responseWare.php";
//     sendResponse(false, "Request timed out.\nPlease check your System clock", null);
// }

$reqStr = strval(json_encode($req));
$hashStr = $salt . $reqStr . strval($timestamp) . $apiKey;
$mHash = md5($hashStr);
if (strcmp($mHash, $hash)) {
    require "responseWare.php";
    sendResponse(false, "Invalid Request: $hashStr", ["interceptedBy" => "MW"]);
}

if (!empty($uid)) {
    if ($endpoint != "saveDeviceId") {
        require("database/db.php");


        $sql = "SELECT * FROM DeviceId WHERE uid = '$uid'";
        $result = $conn->query($sql);




        if ($result && $result->num_rows != 0) {
            $row = $result->fetch_assoc();
            if ($deviceId != $row["deviceId"]) {
                require "responseWare.php";
                sendResponse(false, "LOGOUT: You have been logged out as you logged in on another device", ["interceptedBy" => "MW", "loggedOut" => true]);
            }
        } else {
            $sql = "INSERT INTO `DeviceId` (`id`, `deviceId`, `uid`) VALUES (NULL, '$deviceId', '$uid');";
            $result = $conn->query($sql);
        }


        $conn->close();


    }
}



?>